;***********************************************************************
;
;***********************************************************************
;
;
;
;***********************************************************************
; Copyright (C) 1998 by DOLLmetall Gmbh
;***********************************************************************
;
;	Bearbeiter	: DOLL Markus
;	Datum	  	: 22.04.98
;	Version	: 1.0
;	Update	: 
;	
;***********************************************************************
;
;	Funktion : Z-Koordinaten folgender Elemente werden auf 0 gesetzt
;                  Linie, Polylinie, Kreis, Bogen
;
;***********************************************************************


(defun C:ACH_DOLL ( / Startzeit Zeitdauer Std RestMin Minute Sek)

	(write-line "\n*******************************************************************************")
	(write-line "*****************************  ACH_DOLL Ver. 1.00  ****************************")
	(write-line "***************  Copyright (c) 1998 DOLLmetall Gmbh **************************")
	
	(write-line "*******************************************************************************")

	(setq VZ1 0)
	(setq StartZeit (getvar "DATE"))
	(setvar "CMDECHO" 0)

	(ACH_DOLL_ENT)

	(setq Zeitdauer (- (getvar "DATE") StartZeit))

	(setq Sek (* 86400.0 Zeitdauer))

	(setq Std (/ Sek 3600))
	(setq RestMin (rem Sek 3600))

	(setq Minute (/ RestMin 60))
	(setq Sek (rem RestMin 60))

	(if (= 1 (strlen (setq Std (itoa (fix Std)))))
		(setq Std (strcat "0" std))
	)

	(if (= 1 (strlen (setq Minute (itoa (fix Minute)))))
		(setq Minute (strcat "0" Minute))
	)

	(if (= 1 (strlen (setq Sek (itoa (fix Sek)))))
		(setq Sek (strcat "0" Sek))
	)

	(princ (strcat "\nBentigte Zeit ................. " Std ":" Minute ":" Sek))
	(princ (strcat "\nElemente ....................... "(itoa VZ1)))

	(setq Zeitdauer NIL)
	(setq StartZeit NIL)
	(setq Std NIL)
	(setq Minute NIL)
	(setq RestMin NIL)
	(setq Sek NIL)
	(setq VZ1 NIL)
	(setvar "CMDECHO" 1)
	(prin1)
)


;***********************************************************************
; Die Funktion ACH_DOLL_ENT bearbeitet die Elemente im Entitiesabschnitt
;***********************************************************************

(defun ACH_DOLL_ENT ( / Objekt)

	(Princ "\nEntitiesabschnitt wird bearbeitet\n")

	(setq Objekt (entnext))				; Erstes Element

	(while Objekt
		(ACH_DOLL_CHANGE Objekt "ENTITIES")
		(setq Objekt (entnext Objekt))		; Nchstes Element
	)
	(setq Objekt NIL)
)

;***********************************************************************
; Die Funktion ACH_DOLL_CHANGE
;***********************************************************************

(defun ACH_DOLL_CHANGE (En_Akt Abschnitt / AL_Akt Levelnummer Typ)

	(setq AL_Akt (entget En_Akt))

	; Objekttyp ermitteln

	(setq Typ (cdr (assoc 0 AL_Akt)))
	(setq VZ1 (1+ VZ1))

	(princ "\rElement : ")
	(princ VZ1)

	(cond

		; Element ist Linie

		( (equal Typ "LINE") 
			(setq Al_Akt (ACH_DOLL_CHGLINIE Al_Akt))
			(entmod AL_Akt)
					
		)

		; Element ist Sttzpunkt einer Polylinie

		( (equal Typ "VERTEX")
			(setq Al_Akt (ACH_DOLL_CHGLINIE Al_Akt))
			(entmod AL_Akt)
		)
		
		; Element ist Kreis

		( (equal Typ "CIRCLE")
			(setq Al_Akt (ACH_DOLL_CHGLINIE Al_Akt))
			(entmod AL_Akt)
		)

		; Element ist Bogen

		( (equal Typ "ARC")
			(setq Al_Akt (ACH_DOLL_CHGLINIE Al_Akt))
			(entmod AL_Akt)
		)

		; Alle anderen Elemente

		( T

	 	);EOF COND

	)

)

;------------------------------ ALLGEMEINE FUNKTION --------------------------|

(defun ACH_DOLL_GetVal (n e) (cdr (assoc n e)))

;------------------------------------------------------------------
; Z Koordinaten umwandeln
; Eingangsparameter : ASSOC - Liste einer Linie
; Ausgangsparameter : ASSOC - Liste der neuen Linie
;------------------------------------------------------------------

(defun ACH_DOLL_CHGLINIE ( Al_Akt / ZStartpunkt Zendpunkt Alt)

	;------------------------------------------------------------------
	; Z Koordinaten bestimmen
	;------------------------------------------------------------------

	(setq ZStartpunkt (CADDR (ACH_DOLL_GetVal 10 AL_Akt)))
	(setq ZEndpunkt (CADDR (ACH_DOLL_GetVal 11 AL_Akt)))

	(if (/= ZStartpunkt 0.0)	
		(Progn
		(setq Alt (assoc 10 Al_akt))
		(setq Al_Akt (subst (ACH_DOLL_Znull Alt) Alt Al_Akt))
		); EOF PROGN
	);EOF IF

	(if (/= ZEndpunkt 0.0)	
		(Progn
		(setq Alt (assoc 11 Al_akt))
		(setq Al_Akt (subst (ACH_DOLL_Znull Alt) Alt Al_Akt))
		); EOF PROGN
	);EOF IF


	(setq Al_Akt Al_Akt)
)

;------------------------------------------------------------------
; Z Koordinaten auf Null setzen
;------------------------------------------------------------------

(defun ACH_DOLL_ZNull (Al_Akt / Typ Neu x y)

	(Setq Typ (car Al_Akt))
	(Setq x (cadr Al_Akt))
	(Setq y (caddr Al_Akt))
	
	(Setq Neu (list Typ x y 0.0))
)

